// Demo_FullScreen.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "Demo_FullScreen.h"

#define MAX_LOADSTRING 100



// Global Variables:
HINSTANCE g_hInstance;								// current instance
HMENU g_hMenu = NULL;                        // menu handle
BOOL g_bFullScreen = FALSE;                  // full screen indicator
RECT g_rcNormal = {0};                       // normal window rectangle;

TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_DEMO_FULLSCREEN, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_DEMO_FULLSCREEN));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_DEMO_FULLSCREEN));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL; // MAKEINTRESOURCE(IDC_DEMO_FULLSCREEN);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   g_hInstance = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
   case WM_CREATE:
      g_hMenu = ::LoadMenu(g_hInstance, MAKEINTRESOURCE(IDC_DEMO_FULLSCREEN));
      ::SetMenu(hWnd, g_hMenu);
      break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
      case ID_VIEW_FULLSCREEN: // toggle full screen
         if(g_bFullScreen)
            _ViewNormal(hWnd); 
         else
             _ViewFullScreen(hWnd);
         break;
		case IDM_ABOUT:
			DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
   case WM_CONTEXTMENU:
      {
         POINT point = {0};
         ::GetCursorPos(&point);
         HMENU hMenu = ::LoadMenu(g_hInstance, MAKEINTRESOURCE(IDR_CONTEXT_MENU));
         HMENU hSubMenu = ::GetSubMenu(hMenu, 0);
         MENUITEMINFO mii = {0};
         mii.cbSize = sizeof(MENUITEMINFO);
         mii.fMask = MIIM_STATE;
         mii.fState = g_bFullScreen ? MFS_CHECKED : MFS_UNCHECKED;  
         ::SetMenuItemInfo(hSubMenu, ID_VIEW_FULLSCREEN, FALSE, &mii);
         ::TrackPopupMenu(hSubMenu, TPM_CENTERALIGN, point.x, point.y, 0, hWnd, NULL); 
      }
      break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
      ::TextOut(ps.hdc, 20, 20, _T("F1: shows About"), (int)_tcslen(_T("F1: shows About")));
      ::TextOut(ps.hdc, 20, 40, _T("F11: toggle full screen"), (int)_tcslen(_T("F11: toggle full screen")));
      ::TextOut(ps.hdc, 20, 60, _T("Right-click: shows context menu"), (int)_tcslen(_T("Right-click: shows context menu")));
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

void _ViewFullScreen(HWND hWnd)
{
   // keep in mind normal window rectangle
   ::GetWindowRect(hWnd, &g_rcNormal);

   // remove caption and border styles
   DWORD dwOldStyle = ::GetWindowLong(hWnd, GWL_STYLE);
   DWORD dwNewStyle = dwOldStyle & ~(WS_CAPTION | WS_THICKFRAME);
   ::SetWindowLong(hWnd, GWL_STYLE, dwNewStyle);

   // remove the menu bar
   ::SetMenu(hWnd, NULL);

   // resize to full screen view
   // NOTE: use SWP_FRAMECHANGED to force redraw non-client
   const int x = 0;
   const int y = 0;
   const int cx = ::GetSystemMetrics(SM_CXSCREEN);
   const int cy = ::GetSystemMetrics(SM_CYSCREEN); 
   ::SetWindowPos(hWnd, HWND_TOPMOST, x, y, cx, cy, SWP_FRAMECHANGED);

   // set full screen indicator
   g_bFullScreen = TRUE;
}
void _ViewNormal(HWND hWnd)
{
   // put caption and border styles back
   DWORD dwOldStyle = ::GetWindowLong(hWnd, GWL_STYLE);
   DWORD dwNewStyle = dwOldStyle | WS_CAPTION | WS_THICKFRAME;
   ::SetWindowLong(hWnd, GWL_STYLE, dwNewStyle);

   // put back the menu bar
   ::SetMenu(hWnd, g_hMenu);

   // resize to normal view
   // NOTE: use SWP_FRAMECHANGED to force redraw non-client
   const int x = g_rcNormal.left;
   const int y = g_rcNormal.top;
   const int cx = g_rcNormal.right - g_rcNormal.left;
   const int cy = g_rcNormal.bottom - g_rcNormal.top; 
   ::SetWindowPos(hWnd, HWND_NOTOPMOST, x, y, cx, cy, SWP_FRAMECHANGED);

   // reset full screen indicator
   g_bFullScreen = FALSE;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
